#include <at89c51ed2.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <math.h>
#include <i2c.h>
#include <function.h>

void Int_T100ms(void);
void Int_T1s(void);

unsigned char MByte;
unsigned char pFMByte;

//---------------------------------------------------------
void TIMER1_INT(void) interrupt 1
{
	MByte++;
	if ((MByte & 0x01) && !(pFMByte & 0x01)) Time+=1;
	if ((MByte & 0x02) && !(pFMByte & 0x02)) Int_T100ms();
	if ((MByte & 0x08) && !(pFMByte & 0x08)) Int_T1s();
	pFMByte=MByte;
}

void IO_Input(void)	// Read Data from  all modules
{			
	iI[0]=P1;			
}


void IO_Output(void)	// Write Data to all modules
{
	write_IO(iQ[0],0x40);
}


void RST_IQM(void)
{
	unsigned char i;
	for (i=0; i<50; i++)
	{
	  iI[i]=0;
	  iQ[i]=0;
	}
}


void initialize_system (void)
{
	AUXR=0x2F; 					//  
	TMOD = 0x01;  					//   16 
	TR0=1;	 					//   0
	ET0=1;        					//     0
	EA=1;         					//   

  	i2c_start();                  			// Send I2C Start Transfer
   	i2c_write(0x40);              			// Send identifier I2C address - Write
   	i2c_write(0x06);              			// Send identifier I2C address - Write
   	i2c_write(0x00);			 			// Send control byte to device
   	i2c_stop();                   			// Send I2C Stop Transf

  	i2c_start();                  			// Send I2C Start Transfer
   	i2c_write(0x40);              			// Send identifier I2C address - Write
   	i2c_write(0x07);              			// Send identifier I2C address - Write
   	i2c_write(0xFF);			 			// Send control byte to device
   	i2c_stop();                   			// Send I2C Stop Transf
}

//****************************************************
//--------Create all variable----------
xdata struct sTpPID ASD_pPID1;
xdata struct sTrIN ASD_rIN1;
xdata struct sTrIN ASD_rIN2;
xdata struct sTrIN ASD_rIN4;
xdata struct sTrIN ASD_rIN6;
xdata struct sTrOUT ASD_rOUT1;
xdata struct sTrIN ASD_rIN5;
xdata struct sTbIN ASD_bIN1;
xdata struct sTrIN ASD_rIN7;
xdata struct sTrIN ASD_rIN8;
xdata struct sTrMOVE ASD_rMOVE1;
xdata struct sTrIN ASD_rIN9;
xdata struct sTrOUT ASD_rOUT2;
xdata struct sTrIN ASD_rIN3;
//**************************************
 
//--------Create all function----------
//***** Task ASD*****
void ASD(void)
{
    ASD_rIN5.OUT=0;
    ASD_pPID1.Td=ASD_rIN5.OUT;
 
    ASD_rIN6.OUT=0.100000001490116;
    ASD_pPID1.Cycle=ASD_rIN6.OUT;
 
    ASD_rIN3.OUT=0.200000002980232;
    ASD_pPID1.Kp=ASD_rIN3.OUT;
 
    fTrIN(&ASD_rIN1,2,0);
    ASD_pPID1.SP_A=ASD_rIN1.OUT;
 
    fTrIN(&ASD_rIN2,2,4);
    ASD_pPID1.PV=ASD_rIN2.OUT;
 
    ASD_rIN4.OUT=0.200000002980232;
    ASD_pPID1.Ti=ASD_rIN4.OUT;
 
    ASD_rIN8.OUT=0.200000002980232;
    ASD_pPID1.Dead=ASD_rIN8.OUT;
 
    ASD_pPID1.useEN=0;
    fTpPID(&ASD_pPID1);
    ASD_rOUT1.IN=ASD_pPID1.LMN;
    ASD_rOUT1.EN=1;
 
    ASD_rOUT1.useEN=0;
    fTrOUT(&ASD_rOUT1,2,4);
 
    fTrIN(&ASD_rIN7,2,20);
    ASD_pPID1.SP_M=ASD_rIN7.OUT;
 
    fTbIN(&ASD_bIN1,2,30,0);
    ASD_pPID1.AM=ASD_bIN1.OUT;
    ASD_rMOVE1.EN=ASD_bIN1.OUT;
 
    fTrIN(&ASD_rIN9,2,4);
    ASD_rMOVE1.IN=ASD_rIN9.OUT;
 
    ASD_rMOVE1.useEN=-1;
    fTrMOVE(&ASD_rMOVE1);
    ASD_rOUT2.IN=ASD_rMOVE1.OUT;
    ASD_rOUT2.EN=ASD_rMOVE1.ENO;
 
    ASD_rOUT2.useEN=0;
    fTrOUT(&ASD_rOUT2,2,0);
 
}
 
//***********End all Task***************
 
//-------------Free cycle-------------
void FreeCycle(void)
{
}
 
//-------------Int_OnStart-------------
void Int_OnStart(void)
{
}
 
//-------------Int_T100ms-------------
void Int_T100ms(void)
{
    ASD();
}
 
//-------------Int_T1s-------------
void Int_T1s(void)
{
}
 
//------- main------
void main(void)
{
	initialize_system();
	Int_OnStart(); 		// OnStartUp function
	while(1)
	{
		IO_Input(); 	// Read from input 
 		FreeCycle();	// Free cycle function
		IO_Output();
	}
}